ur_rna.StructureEditor.services.drawing

## Class SelectionRotater.CenterPoint

- java.lang.Object
- - ur_rna.StructureEditor.services.drawing.DrawHandle
  - - ur_rna.StructureEditor.services.drawing.SelectionRotater.CenterPoint

- Enclosing class:
    SelectionRotater

      public static class SelectionRotater.CenterPoint
      extends DrawHandle

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private SelectionRotater.RotationCenter` | `center`
    `private Motif.Helix` | `customHelix`
    `private Nuc` | `customNuc`
    `private java.awt.geom.Point2D.Float` | `modelLocation`
    `private SelectionRotater` | `owner`
    `private java.awt.geom.Point2D.Float` | `previousCenter`
    `private int` | `selectionHash`

    - ### Fields inherited from class ur_rna.StructureEditor.services.drawing.DrawHandle

      `_tmpPt, _tmpTr, allNucs, boxSize, cachedBounds, controller, customCursor, defaultBgColor, defaultLineColor, defaultOutline, icon, location, SNAP_DISTANCE, startLocation, targetNuc, view`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CenterPoint(SceneController controller, SelectionRotater owner)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `calcLocation(java.awt.geom.Point2D.Float p)`
    `private void` | `calcLocation(java.awt.geom.Point2D.Float p, SelectionRotater.RotationCenter rc)`
    `SceneUpdateInfo` | `getCompletionEvent()`
    `boolean` | `isValid()`
    `protected void` | `nucPositionsChanged()` Called when any nucleotides in the scene changed position, EXCEPT when THIS DrawHandle is in the middle of a performDrag operation (because any nucleotide changes then are likely due to its own drag operation).
    `protected void` | `performDrag(java.awt.Point start, java.awt.Point prev, java.awt.Point current, SceneController.DragOpts options)` Called when this handle has been dragged by the user.
    `protected void` | `prepareDraw(boolean isDragging)`
    `private void` | `reset()`
    `void` | `saveRelativeLocation()`
    `protected void` | `selectionChanged()`

    - ### Methods inherited from class ur_rna.StructureEditor.services.drawing.DrawHandle

      `calcBoxPos, drag, dragComplete, dragStarted, draw, drawBox, getBounds, getBoxSize, getModelSpaceDeltaTransform, isEnabled, isUpdating, layoutUpdated, moveLocation, setBoxSize, setEnabled, setIcon, setSelection, settingsChanged`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### center

          private SelectionRotater.RotationCenter center

    - #### customHelix

          private Motif.Helix customHelix

    - #### customNuc

          private Nuc customNuc

    - #### modelLocation

          private java.awt.geom.Point2D.Float modelLocation

    - #### owner

          private final SelectionRotater owner

    - #### previousCenter

          private java.awt.geom.Point2D.Float previousCenter

    - #### selectionHash

          private int selectionHash

  - ### Constructor Detail

    - #### CenterPoint

          public CenterPoint(SceneController controller,
                             SelectionRotater owner)

  - ### Method Detail

    - #### calcLocation

          private void calcLocation(java.awt.geom.Point2D.Float p)

    - #### calcLocation

          private void calcLocation(java.awt.geom.Point2D.Float p,
                                    SelectionRotater.RotationCenter rc)

    - #### getCompletionEvent

          public SceneUpdateInfo getCompletionEvent()

      Specified by:
        `getCompletionEvent` in class `DrawHandle`

    - #### isValid

          public boolean isValid()

      Specified by:
        `isValid` in class `DrawHandle`

    - #### nucPositionsChanged

          protected void nucPositionsChanged()

      Description copied from class: `DrawHandle`
      Called when any nucleotides in the scene changed position, EXCEPT when THIS DrawHandle is in the middle of a performDrag operation (because any nucleotide changes then are likely due to its own drag operation).
      Specified by:
        `nucPositionsChanged` in class `DrawHandle`

    - #### performDrag

          protected void performDrag(java.awt.Point start,
                                     java.awt.Point prev,
                                     java.awt.Point current,
                                     SceneController.DragOpts options)

      Description copied from class: `DrawHandle`
      Called when this handle has been dragged by the user.
      Specified by:
        `performDrag` in class `DrawHandle`

    - #### prepareDraw

          protected void prepareDraw(boolean isDragging)

      Specified by:
        `prepareDraw` in class `DrawHandle`

    - #### reset

          private void reset()

    - #### saveRelativeLocation

          public void saveRelativeLocation()

    - #### selectionChanged

          protected void selectionChanged()

      Specified by:
        `selectionChanged` in class `DrawHandle`